#include "command.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int scan_command(strlist* tokens, command* cmd) {
   char* path; int oflags;
   strlist_clear(&cmd->argv);
   for (int fd = 0; fd < 2; ++fd) {
      cmd->assignments[fd].path = 0;
   }
   cmd->background = 0;
   for (int i = 0; i < tokens->len; ++i) {
      switch (tokens->list[i][0]) {
         case '<':
            cmd->assignments[0].path = &tokens->list[i][1];
            cmd->assignments[0].oflags = O_RDONLY;
            cmd->assignments[0].mode = 0;
            break;
         case '>':
            path = &tokens->list[i][1];
            oflags = O_WRONLY|O_CREAT;
            if (*path == '>') {
               ++path; oflags |= O_APPEND;
            } else {
               oflags |= O_TRUNC;
            }
            cmd->assignments[1].path = path;
            cmd->assignments[1].oflags = oflags;
            cmd->assignments[1].mode = 0666;
            break;
         case '&':
	    if (tokens->list[i][1] == 0) {
	       cmd->background = 1;
	       break;
	    }
	    /* fall into */
         default:
            strlist_push(&cmd->argv, tokens->list[i]);
            if (cmd->cmdname == 0) {
               cmd->cmdname = tokens->list[i];
            }
      }
   }
   strlist_push0(&cmd->argv);
   return cmd->cmdname != 0;
}

/* assign an opened file with the given flags and mode to fd */
void fassign(int fd, char* path, int oflags, mode_t mode) {
   int newfd = open(path, oflags, mode);
   if (newfd < 0) {
      perror(path); exit(255);
   }
   if (dup2(newfd, fd) < 0) {
      perror("dup2"); exit(255);
   }
   close(newfd);
}

void exec_command(command* cmd) {
   for (int fd = 0; fd < 2; ++fd) {
      if (cmd->assignments[fd].path != 0) {
         fassign(fd, cmd->assignments[fd].path,
            cmd->assignments[fd].oflags,
            cmd->assignments[fd].mode);
      }
   }
   execvp(cmd->cmdname, cmd->argv.list);
}
